<?php

namespace RxConnexionBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use RxConnexionBundle\Entity\Base\BaseEntity;
use Symfony\Component\Form\Extension\Core\DataTransformer\DateTimeToStringTransformer;

/**
 * @ORM\Entity(repositoryClass="RxConnexionBundle\Repository\MarketingStaffScheduleQueuedRepository")
 * @ORM\Table(name="marketing_staff_schedule_queued")
 */

class MarketingStaffScheduleQueuedEntity extends BaseEntity
{
    /**
     * @ORM\Column(name="schedule_date", type="datetime")
     */
    protected $scheduleDate;

    /**
     * @ORM\Column(name="notes", type="text", nullable=true)
     */
    protected $notes;

    /**
     * @ORM\Column(name="is_queued", type="boolean", nullable=true)
     */
    protected $isQueued = true;

    /**
     * @ORM\Column(name="queue_no", type="integer", nullable=true)
     */
    protected $queueNo;

    /**
     * @ORM\Column(name="is_deleted", type="boolean")
     */
    protected $isDeleted;

    /**
     * @ORM\ManyToOne(targetEntity="HealthFacilityEntity", inversedBy="marketingStaffSchedulesQueued")
     * @ORM\JoinColumn(name="health_facility_id", referencedColumnName="id")
     */
    protected $healthFacility;

    /**
     * @ORM\ManyToOne(targetEntity="PatientEntity", inversedBy="marketingStaffSchedulesQueued")
     * @ORM\JoinColumn(name="patient_id", referencedColumnName="id")
     */
    protected $patient;

    /**
     * @ORM\ManyToOne(targetEntity="MarketingStaffScheduleQueuedStatusEntity", inversedBy="marketingStaffSchedulesQueued")
     * @ORM\JoinColumn(name="marketing_staff_schedule_queued_status_id", referencedColumnName="id")
     */
    protected $marketingStaffScheduleQueuedStatus;

    /**
     * @ORM\ManyToOne(targetEntity="ChartTypeEntity", inversedBy="marketingStaffSchedulesQueued")
     * @ORM\JoinColumn(name="chart_type_id", referencedColumnName="id")
     */
    protected $chartType;

    /**
     * @ORM\OneToOne(targetEntity="MarketingStaffScheduleRequestEntity", inversedBy="marketingStaffScheduleQueued")
     * @ORM\JoinColumn(name="marketing_staff_schedule_request_id", referencedColumnName="id")
     */
    protected $marketingStaffScheduleRequest;

    /**
     * @ORM\ManyToOne(targetEntity="MarketingStaffEntity", inversedBy="marketingStaffSchedulesQueued")
     * @ORM\JoinColumn(name="marketing_staff_id", referencedColumnName="id")
     */
    protected $marketingStaff;

    /**
     * Set createdAt
     *
     * @ORM\PrePersist
     */
    public function setCreatedAtValue()
    {
        parent::setCreatedAtValue();
        $this->isDeleted = 0;
    }

    /*--------------------------------------------------------------------------------------------------------*/
    /*					Use Defined Setters and Getters														  */
    /*--------------------------------------------------------------------------------------------------------*/

    /*--------------------------------------------------------------------------------------------------------*/
    /*					Setters and Getters																	  */
    /*--------------------------------------------------------------------------------------------------------*/



    /**
     * Set scheduleDate
     *
     * @param \DateTime $scheduleDate
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setScheduleDate($scheduleDate)
    {
        $this->scheduleDate = $scheduleDate;

        return $this;
    }

    /**
     * Get scheduleDate
     *
     * @return \DateTime
     */
    public function getScheduleDate()
    {
        return $this->scheduleDate;
    }

    /**
     * Set notes
     *
     * @param string $notes
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setNotes($notes)
    {
        $this->notes = $notes;

        return $this;
    }

    /**
     * Get notes
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * Set isQueued
     *
     * @param boolean $isQueued
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setIsQueued($isQueued)
    {
        $this->isQueued = $isQueued;

        return $this;
    }

    /**
     * Get isQueued
     *
     * @return boolean
     */
    public function getIsQueued()
    {
        return $this->isQueued;
    }

    /**
     * Set queueNo
     *
     * @param integer $queueNo
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setQueueNo($queueNo)
    {
        $this->queueNo = $queueNo;

        return $this;
    }

    /**
     * Get queueNo
     *
     * @return integer
     */
    public function getQueueNo()
    {
        return $this->queueNo;
    }

    /**
     * Set isDeleted
     *
     * @param boolean $isDeleted
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setIsDeleted($isDeleted)
    {
        $this->isDeleted = $isDeleted;

        return $this;
    }

    /**
     * Get isDeleted
     *
     * @return boolean
     */
    public function getIsDeleted()
    {
        return $this->isDeleted;
    }

    /**
     * Set healthFacility
     *
     * @param \RxConnexionBundle\Entity\HealthFacilityEntity $healthFacility
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setHealthFacility(\RxConnexionBundle\Entity\HealthFacilityEntity $healthFacility = null)
    {
        $this->healthFacility = $healthFacility;

        return $this;
    }

    /**
     * Get healthFacility
     *
     * @return \RxConnexionBundle\Entity\HealthFacilityEntity
     */
    public function getHealthFacility()
    {
        return $this->healthFacility;
    }

    /**
     * Set patient
     *
     * @param \RxConnexionBundle\Entity\PatientEntity $patient
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setPatient(\RxConnexionBundle\Entity\PatientEntity $patient = null)
    {
        $this->patient = $patient;

        return $this;
    }

    /**
     * Get patient
     *
     * @return \RxConnexionBundle\Entity\PatientEntity
     */
    public function getPatient()
    {
        return $this->patient;
    }

    /**
     * Set marketingStaffScheduleQueuedStatus
     *
     * @param \RxConnexionBundle\Entity\MarketingStaffScheduleQueuedStatusEntity $marketingStaffScheduleQueuedStatus
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setMarketingStaffScheduleQueuedStatus(\RxConnexionBundle\Entity\MarketingStaffScheduleQueuedStatusEntity $marketingStaffScheduleQueuedStatus = null)
    {
        $this->marketingStaffScheduleQueuedStatus = $marketingStaffScheduleQueuedStatus;

        return $this;
    }

    /**
     * Get marketingStaffScheduleQueuedStatus
     *
     * @return \RxConnexionBundle\Entity\MarketingStaffScheduleQueuedStatusEntity
     */
    public function getMarketingStaffScheduleQueuedStatus()
    {
        return $this->marketingStaffScheduleQueuedStatus;
    }

    /**
     * Set chartType
     *
     * @param \RxConnexionBundle\Entity\ChartTypeEntity $chartType
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setChartType(\RxConnexionBundle\Entity\ChartTypeEntity $chartType = null)
    {
        $this->chartType = $chartType;

        return $this;
    }

    /**
     * Get chartType
     *
     * @return \RxConnexionBundle\Entity\ChartTypeEntity
     */
    public function getChartType()
    {
        return $this->chartType;
    }

    /**
     * Set marketingStaffScheduleRequest
     *
     * @param \RxConnexionBundle\Entity\MarketingStaffScheduleRequestEntity $marketingStaffScheduleRequest
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setMarketingStaffScheduleRequest(\RxConnexionBundle\Entity\MarketingStaffScheduleRequestEntity $marketingStaffScheduleRequest = null)
    {
        $this->marketingStaffScheduleRequest = $marketingStaffScheduleRequest;

        return $this;
    }

    /**
     * Get marketingStaffScheduleRequest
     *
     * @return \RxConnexionBundle\Entity\MarketingStaffScheduleRequestEntity
     */
    public function getMarketingStaffScheduleRequest()
    {
        return $this->marketingStaffScheduleRequest;
    }

    /**
     * Set marketingStaff
     *
     * @param \RxConnexionBundle\Entity\MarketingStaffEntity $marketingStaff
     *
     * @return MarketingStaffScheduleQueuedEntity
     */
    public function setMarketingStaff(\RxConnexionBundle\Entity\MarketingStaffEntity $marketingStaff = null)
    {
        $this->marketingStaff = $marketingStaff;

        return $this;
    }

    /**
     * Get marketingStaff
     *
     * @return \RxConnexionBundle\Entity\MarketingStaffEntity
     */
    public function getMarketingStaff()
    {
        return $this->marketingStaff;
    }
}
